ifndef			_PICTURE_ASM
_PICTURE_ASM		equ	1

; ------------------------------------------------------
; Load BMP JPEG GIF EMF WMF ICO pictures in memory done by Siekmanski
; Copyright (c) 2005, Franck Charlet
; All rights reserved.
; ------------------------------------------------------

; ------------------------------------------------------
; Includes

			include     ..\Include\CoInvoke.inc

                  include 	ole32.inc
                  include 	oleaut32.inc
                  includelib	ole32.lib
                  includelib	oleaut32.lib

sIID_IPicture     TEXTEQU <{07bf80980h,0bf32h,0101ah,{08bh,0bbh,000h,0aah,000h,030h,00ch,0abh}}>

_vtIPicture MACRO CastName:REQ
        _vtIUnknown CastName
        &CastName&_get_Handle              comethod2  ?
        &CastName&_get_hPal                comethod2  ?
        &CastName&_get_Type                comethod2  ?
        &CastName&_get_Width               comethod2  ?
        &CastName&_get_Height              comethod2  ?
        &CastName&_Render                  comethod11 ?
        &CastName&_set_hPal                comethod2  ?
        &CastName&_get_CurDC               comethod2  ?
        &CastName&_SelectPicture           comethod4  ?
        &CastName&_get_KeepOriginalFormat  comethod2  ?
        &CastName&_put_KeepOriginalFormat  comethod2  ?
        &CastName&_PictureChanged          comethod1  ?
        &CastName&_SaveAsFile              comethod4  ?
        &CastName&_get_Attributes          comethod2  ?
ENDM

IPicture STRUCT
        _vtIPicture    IPicture
IPicture ENDS

HIMETRIC_INCH     equ  2540

.data                             
IID_IPicture      GUID sIID_IPicture
.code

			include	Files.asm

; ------------------------------------------------------
; Structures
BMP			struct
_Datas			dword	?
_Width			dword	?
_Height			dword	?
_Bits			dword	?
BMP			ends

; ------------------------------------------------------
; Name: Load_PICTURE()
; Desc: Load a BMP GIF JPG EMF WMF ICO file into memory
Load_PICTURE	proc	PICTURE_FName:dword, PICTURE_Struct:dword
			local	PICTURE_Buffer:dword
			local	FSize:dword
			local	DatOffset:dword
                  local pStream:dword
                  local pPicture:dword

                  local	hdcTemp:HDC
                  local	hbmpTemp:HBITMAP
                  local binfo:BITMAPINFO
                  local pBits:dword
                  local IPicWidth:dword
                  local IPicHeight:dword
                  
			mov	esi, PICTURE_Struct
			mov	[esi + BMP._Datas], NULL
                  mov	[esi + BMP._Bits], 32  ; only 32 bits

			; Load texture into memory
			invoke	Load_File, PICTURE_FName, addr FSize
			test	eax, eax
			jz	Err_PIC_Load
			mov	PICTURE_Buffer, eax

                  invoke      CreateStreamOnHGlobal, PICTURE_Buffer, TRUE, addr pStream
                  cmp   eax, S_OK
                  jne   Err_PIC_CStream

                  invoke      OleLoadPicture, pStream, NULL, TRUE, addr IID_IPicture, addr pPicture
                  cmp   eax, S_OK
                  jne   Err_PIC_Stream

                  invoke      GetDC,NULL
                  push  eax
                  invoke      CreateCompatibleDC, eax
                  mov   hdcTemp, eax
                  pop   eax
                  invoke      DeleteDC, eax

                    ; get IPicture width and height
                  coinvoke	pPicture, IPicture, get_Width, addr IPicWidth
                  coinvoke	pPicture, IPicture, get_Height, addr IPicHeight
                    ; convert to pixels
                  invoke      GetDeviceCaps, hdcTemp, LOGPIXELSX
                  invoke      MulDiv, IPicWidth, eax, HIMETRIC_INCH
                  mov   [esi + BMP._Width], eax
                  invoke      GetDeviceCaps, hdcTemp, LOGPIXELSY
                  invoke      MulDiv, IPicHeight, eax, HIMETRIC_INCH
                  mov   [esi + BMP._Height], eax

                  invoke      RtlZeroMemory, addr binfo.bmiHeader, sizeof ( BITMAPINFOHEADER )

                  mov   binfo.bmiHeader.biSize, sizeof ( BITMAPINFOHEADER )
                  mov	eax, [esi + BMP._Bits]
                  mov   binfo.bmiHeader.biBitCount, ax
                  mov   eax, [esi + BMP._Width]
                  mov   binfo.bmiHeader.biWidth, eax
                  mov   eax, [esi + BMP._Height]
                  mov   binfo.bmiHeader.biHeight, eax
                  mov   binfo.bmiHeader.biCompression, BI_RGB
                  mov   binfo.bmiHeader.biPlanes, 1

                  invoke      CreateDIBSection, hdcTemp,addr binfo, DIB_RGB_COLORS,addr pBits, NULL, 0
            	test	eax, eax
	            jz	Err_PIC_DIB
                  mov   hbmpTemp, eax

                  invoke      SelectObject, hdcTemp, hbmpTemp

                  mov   eax, IPicHeight
                  neg   eax
                  coinvoke    pPicture, IPicture, Render, hdcTemp, 0, 0, [esi + BMP._Width], [esi + BMP._Height], 0, IPicHeight, IPicWidth, eax, 0
                  cmp   eax, S_OK
                  jne   Err_PIC_Render

                  mov	eax, [esi + BMP._Width]
			imul	eax, [esi + BMP._Height]
			push	eax
			shl	eax, 2
			invoke	GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, eax
			pop	ecx
			test	eax, eax
			jz	Err_PIC_Render

			mov	[esi + BMP._Datas], eax
                  	mov   edi,eax

			mov	esi,pBits		; 32 bits image datas
Copy_32BitPixels:		lodsb
				ror	eax, 8
				lodsb
				ror	eax, 8
				lodsb
				ror	eax, 8 
				lodsb
				bswap	eax
				stosd
				loop	Copy_32BitPixels

                  	invoke      DeleteObject, hbmpTemp
                  	invoke      DeleteDC, hdcTemp

                  	SAFE_RELEASE pPicture
                  	SAFE_RELEASE pStream

            	  	invoke	GlobalFree, PICTURE_Buffer
			mov	eax, TRUE			; Loaded
			ret

Err_PIC_Render:   invoke      DeleteObject, hbmpTemp
Err_PIC_DIB:      invoke      DeleteDC, hdcTemp
                  SAFE_RELEASE pPicture
Err_PIC_Stream:   SAFE_RELEASE pStream
Err_PIC_CStream:  invoke	GlobalFree, PICTURE_Buffer
Err_PIC_Load:	xor	eax, eax				; Not loaded
			ret
Load_PICTURE      endp


; ------------------------------------------------------
; Name: Unload_PICTURE()
; Desc: Free an allocated picture
Unload_PICTURE	proc	PICTURE_Struct:dword
			mov	esi, PICTURE_Struct
			mov	eax, [esi + BMP._Datas]
			test	eax, eax
			jz	@F
			invoke	GlobalFree, eax
@@:			ret
Unload_PICTURE	endp

endif
